#![no_std]
#![no_main]

use user_lib::syscall::{sys_fork, sys_yield, sys_exec};
use user_lib::{println, wait};

#[no_mangle]
fn main() -> i32 {
    if sys_fork() == 0 {
        // 注意需要手动添加\0 转为 c_str
        sys_exec("user_shell\0");
    } else {
        loop {
            let mut exit_code: i32 = 0;
            let pid = wait(&mut exit_code);
            if pid == -1 {
                sys_yield();
                continue;
            }
            println!(
                "[initproc] Released a zombie process, pid={}, exit_code={}",
                pid, exit_code,
            );
        }
    }
    0
}
